package com.iloomo.dao.core;

import java.util.Map;
import java.util.List;
import com.iloomo.entity.core.KeyValue;
import com.iloomo.util.PageData;
import com.iloomo.util.PagerModel;

/** 
 * 说明：表 keyValue数据处理接口
 * 创建人：system
 * 创建时间：2020-02-13
 * @version
 */
public interface KeyValueDao{

	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public int save(PageData pd) throws Exception;
	
	/**根据id删除数据
	 * @param pd
	 * @throws Exception
	 */
	public int deleteById(PageData pd) throws Exception;
	
	/**根据id修改数据
	 * @param pd
	 * @throws Exception
	 */
	public int updateById(PageData pd) throws Exception;
	
	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public Map findById(PageData pd) throws Exception;
	
	/**列表(分页)
	 * @param pd
	 * @throws Exception
	 */
	public PagerModel list(PageData pd) throws Exception;
	
	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<Map> listAll(PageData pd) throws Exception;
	/**批量保存
	* @param objs
	* @throws Exception
	*/
	public Object batchSave(List objs) throws Exception;
	/**列表(分页)
	* @param pd
	* @throws Exception
	*/
	public PagerModel listWithLike(PageData pd) throws Exception;

	/**列表(全部)
	* @param pd
	* @throws Exception
	*/
	public List<Map> listAllWithLike(PageData pd) throws Exception;

	//查询总数
	public int selectCount(PageData pd) throws Exception;
	}


